%define _ssldir %(openssl-config --openssldir)
%define _pemdir %_ssldir/private
#%define dist_tag %nil 
#%if_with Master
#%define dist_tag Master
#%endif
#%if_with Sisyphus
#%define dist_tag Sisyphus
#%endif
#%if "%dist_tag" == ""
#%define dist_tag %(cut -d" " -f3 < /etc/altlinux-release)
#%endif

# Optional builds
# _with_pgsql
# _with_mysql
# _with_tls
# _with_ldap
# --with pgsql --with mysql --with tls --with ldap
Name: pure-ftpd
Version: 1.0.19
Release: alt1.1
URL: http://www.pureftpd.org
Source: %name-%version.tar.bz2
Source1: %name.init.master
Source2: %name.init.sisyphus
Source3: %name.logrotate
Source4: %name.xinetd
Source5: ftpallow
Source6: ftpusers
Source7: %name.default
Patch1: %name-1.0.18-conf.patch
Patch2: %name-1.0.18-docs.patch
Group: System/Servers
License: BSD
Provides: ftp-server ftpserver pure-ftpd
Summary: Lightweight, fast and secure FTP server
Conflicts: wu-ftpd, ncftpd, proftpd, vsftpd
#%if "%dist_tag" == "Master"
#Requires(post,preun): initscripts
#%else
Requires(post,preun): service
#%endif
#%if "%dist_tag" == "Master"
#BuildRequires: libpam-devel %{?_with_ldap:libldap-devel} %{?_with_mysql:libMySQL-devel zlib-devel}
#BuildRequires: libcap-devel %{?_with_pgsql:postgresql-devel} %{?_with_tls:libssl-devel}
#%else
BuildRequires: libpam0-devel %{?_with_ldap:libldap-devel} %{?_with_mysql:libMySQL-devel zlib-devel}
BuildRequires: libcap-devel %{?_with_pgsql:postgresql-devel} %{?_with_tls:libssl-devel}
#%endif

%description
Pure-FTPd is a fast, production-quality, standard-comformant FTP server,
based upon Troll-FTPd. Unlike other popular FTP servers, it has no known
security flaw, it is really trivial to set up and it is especially designed
for modern Linux and FreeBSD kernels (setfsuid, sendfile, capabilities) .
Features include PAM support, IPv6, chroot()ed home directories, virtual
domains, built-in LS, anti-warez system, bandwidth throttling, FXP, bounded
ports for passive downloads, UL/DL ratios, native LDAP and SQL support,
Apache log files and more.
--------
Optional : ldap mysql pgsql tls
Enabled  :%{?_with_ldap: ldap}%{?_with_mysql: mysql}%{?_with_pgsql: pgslq}%{?_with_tls: tls}

%prep
%setup -q -n %name-%version
%patch1 -p1
%patch2 -p1 

%build
%configure \
  --sysconfdir=%_sysconfdir/%name \
  --with-altlog \
  --with-extauth \
  --with-puredb \
  --with-cookie \
  --with-throttling \
  --with-ratios \
  --with-quotas \
  --with-ftpwho \
  --with-uploadscript \
  --with-virtualhosts \
  --with-virtualchroot \
  --with-diraliases \
  --with-peruserlimits \
  --with-pam \
  %{?_with_ldap: --with-ldap} \
  %{?_with_mysql: --with-mysql} \
  %{?_with_pgsql: --with-pgslq} \
  %{?_with_tls: --with-tls --with-certfile=%_pemdir/%name.pem }

echo '#define   VHOST_PATH    "%_sysconfdir/%name/vhost"' >> config.h

%make_build

%install 
%makeinstall

%__mkdir_p %buildroot%_sysconfdir/%name
%__mkdir_p %buildroot%_sysconfdir/%name/vhost
%__mkdir_p %buildroot%_sysconfdir/xinetd.d/
%__mkdir_p %buildroot%_sysconfdir/sysconfig/
%__mkdir_p %buildroot%_sysconfdir/pam.d/
%__mkdir_p %buildroot%_sysconfdir/logrotate.d/
%__mkdir_p %buildroot%_initrddir
%__mkdir_p %buildroot%_var/log/%name
%__mkdir_p -m 700 %buildroot%_var/run/%name

%__install -m 600 pam/pure-ftpd %buildroot%_sysconfdir/pam.d/%name
%__install -m 644 %SOURCE3 %buildroot%_sysconfdir/logrotate.d/%name
%__install -m 644 %SOURCE4 %buildroot%_sysconfdir/xinetd.d/%name
%__install -m 644 %SOURCE5 %buildroot%_sysconfdir/ftpallow
%__install -m 644 %SOURCE6 %buildroot%_sysconfdir/ftpusers
%__install -m 644 %SOURCE7 %buildroot%_sysconfdir/sysconfig/%name

%__install -m 644 configuration-file/pure-ftpd.conf %buildroot%_sysconfdir/%name/%name.conf
%__install -m 755 configuration-file/pure-config.py %buildroot%_sbindir

%__install -m 644 man/pure-ftpd.8 %buildroot%_man8dir
%__install -m 644 man/pure-ftpwho.8 %buildroot%_man8dir
%__install -m 644 man/pure-mrtginfo.8 %buildroot%_man8dir
%__install -m 644 man/pure-uploadscript.8 %buildroot%_man8dir
%__install -m 644 man/pure-pw.8 %buildroot%_man8dir
%__install -m 644 man/pure-pwconvert.8 %buildroot%_man8dir
%__install -m 644 man/pure-statsdecode.8 %buildroot%_man8dir
%__install -m 644 man/pure-quotacheck.8 %buildroot%_man8dir
%__install -m 644 man/pure-authd.8 %buildroot%_man8dir

#%if "%dist_tag" == "Master"
#  %__install -m 755 %SOURCE1 %buildroot%_initrddir/%name
#%else
  %__install -m 755 %SOURCE2 %buildroot%_initrddir/%name
#%endif

%if_with ldap
  %__mkdir_p %buildroot%_sysconfdir/openldap/schema
  %__install -m 644 pureftpd-ldap.conf %buildroot%_sysconfdir/%name
  %__install -m 644 pureftpd.schema %buildroot%_sysconfdir/openldap/schema/pureftpd.schema
%endif

%if_with mysql
  %__install -m 644 pureftpd-mysql.conf %buildroot%_sysconfdir/%name
%endif

%if_with pgsql
  %__install -m 644 pureftpd-pgsql.conf %buildroot%_sysconfdir/%name
%endif

%if_with tls
  %__mkdir_p %buildroot%_pemdir
  touch %buildroot%_pemdir/%name.pem
%endif

# bytecompile-python off
unset RPM_PYTHON

%clean

%pre
/usr/sbin/usermod -d /var/ftp ftp >/dev/null 2>&1 || :

%post
%post_service %name

%if_with tls
# create a ssl cert
if [ ! -f %_pemdir/%name.pem ]; then
pushd %_pemdir &>/dev/null
umask 077
cat << EOF | openssl req -new -x509 -days 365 -nodes -out %name.pem -keyout %name.pem &>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
localhost.localdomain
root@localhost.localdomain
EOF
chown root.root %name.pem
chmod 600 %name.pem
popd &>/dev/null
fi
exit 0
%endif

%preun
%preun_service %name

%files
%defattr(-, root, root)
%_bindir/pure-pw
%_bindir/pure-pwconvert
%_bindir/pure-statsdecode
%_sbindir/pure-config.py
%_sbindir/pure-ftpd
%_sbindir/pure-ftpwho
%_sbindir/pure-uploadscript
%_sbindir/pure-mrtginfo
%_sbindir/pure-quotacheck
%_sbindir/pure-authd

%_sysconfdir/ftpallow
%_sysconfdir/ftpusers

%_man8dir/*

%dir %_sysconfdir/%name/vhost
%dir %_var/log/%name
%dir %_var/run/%name

%config %_initrddir/%name
%config(noreplace) %_sysconfdir/%name/%name.conf
%config(noreplace) %_sysconfdir/sysconfig/%name
%config(noreplace) %_sysconfdir/pam.d/%name
%config(noreplace) %_sysconfdir/logrotate.d/%name
%config(noreplace) %_sysconfdir/xinetd.d/%name
%{?_with_ldap: %config(noreplace) %_sysconfdir/%name/pureftpd-ldap.conf}
%{?_with_ldap: %config(noreplace) %_sysconfdir/openldap/schema/pureftpd.schema}
%{?_with_mysql: %config(noreplace) %_sysconfdir/%name/pureftpd-mysql.conf}
%{?_with_pgsql: %config(noreplace) %_sysconfdir/%name/pureftpd-pgsql.conf}
%{?_with_tls: %ghost %attr(0600,root,root) %verify(not md5 size mtime) %config(missingok,noreplace) %_pemdir/%name.pem}

%doc FAQ THANKS AUTHORS CONTACT HISTORY NEWS pure-ftpd.png  
%doc contrib/pure-stat.pl contrib/pure-vpopauth.pl contrib/xml_python_processors.txt
%doc README README.* pureftpd.schema
%doc pureftpd-ldap.conf pureftpd-mysql.conf pureftpd-pgsql.conf

%changelog
* Thu Jan 12 2006 ALT QA Team Robot <qa-robot@altlinux.org> 1.0.19-alt1.1
- Rebuilt for new style PAM dependencies generated by rpm-build-4.0.4-alt55.

* Mon Jun 21 2004 Konstantin Klimchev <koka@altlinux.ru> 1.0.19-alt1
- new version 1.0.19
- comments master2.2 build

* Mon Apr 12 2004 Konstantin Klimchev <koka@altlinux.ru> 1.0.18-alt1
- disable xinetd server by default, using the standalone one

* Thu Mar 18 2004 Konstantin Klimchev <koka@altlinux.ru> 1.0.18-alt0.1
- add Sisyphus-style init-script
- add seperate build (Sisyphus vs Master)

* Fri Feb 27 2004 Konstantin Klimchev <koka@altlinux.ru> 1.0.17a-alt0.2
- return init-script (ALTM22-style). Sisyphus-style - TODO.
- add VHOST_PATH

* Tue Feb 3 2004 Konstantin Klimchev <koka@altlinux.ru> 1.0.17a-alt0.1
- initial build for Daedalus

* Mon Feb 2 2004 Konstantin Klimchev <koka@atvc.ru> 1.0.17a-2
- fixed path of ssl-cert file

* Wed Nov 26 2003 Konstantin Klimchev <koka@atvc.ru> 1.0.17a-1
- disabled standalone by default, using the xinetd server

* Tue Nov 18 2003 Konstantin Klimchev <koka@atvc.ru> 1.0.16c-2
- add %_sysconfdir/sysconfig/pure-ftpd

* Thu Nov 12 2003 Konstantin Klimchev <koka@atvc.ru> 1.0.16c-1
- 1.0.16c
- edit spec

* Wed Aug 13 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.0.16-1mdk
- 1.0.16

* Sat Jul 19 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.14-6mdk
- rebuild

* Sat Apr 19 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0.14-5mdk
- use configure2_5x macro
- remove anonftp provides

* Wed Apr 02 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.14-4mdk
- rebuild against libmysql12

* Mon Feb 03 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.14-3mdk
- disable xinetd server by default, using the standalone one

* Mon Feb 03 2003 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.14-2mdk
- source 3 : add xinetd support

* Mon Feb  3 2003 Laurent Culioli <laurent@pschit.net> 1.0.14-1mdk
- 1.0.14

* Tue Jan 16 2003 Laurent Culioli <laurent@pschit.net> 1.0.13a-1mdk
- 1.0.13a
- remove hardcoded packager tag

* Tue Dec 31 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.0.12-6mdk
- from Brook Humphrey <bah@webmedic.net> :
	- fixed anonymous users
	- fixed ftp user not being added to ftp groups

* Mon Sep  9 2002 Arnaud Desmons <adesmons@mandrakesoft.com> 1.0.12-5mdk
- fixed invalid-packager Laurent Culioli

* Fri Aug 23 2002 Laurent Culioli <laurent@pschit.net> 1.0.12-4mdk
- fix logrotate
- add --with-diraliases options

* Tue Aug 13 2002 Laurent Culioli <laurent@pschit.net> 1.0.12-3mdk
- add logrotate support

* Tue Jun 18 2002 Laurent Culioli <laurent@mandrakesoft.com> 1.0.12-2mdk
- add user-limit support
- add pure-ftpd.png

* Tue Jun 11 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.0.12-1mdk
- 1.0.12

* Fri Mar  8 2002 Laurent Culioli <laurent@mandrakesoft.com> 1.0.10-1mdk
- 1.0.10

* Fri Feb 22 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.0.9-1mdk
- 1.0.9

* Fri Jan 25 2002 Laurent Culioli <laurent@mandrakesoft.com> 1.0.8-3mdk
- really add postgresql support
- add extauth support
- add conflict with vsftpd

* Fri Jan 25 2002 Laurent Culioli <laurent@mandrakesoft.com> 1.0.8-2mdk
- add support for pgsql and virtual-chroot
- add mdkconf patch ( change _sysconfigdir from /etc to /etc/pure-ftpd )

* Fri Jan 25 2002 Lenny Cartier <lenny@mandrakesoft.com> 1.0.8-1mdk
- 1.0.8

* Sun Dec 30 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.0.7-1mdk
- 1.0.7
- remove now integrated patch

* Tue Nov 13 2001 Laurent Culioli <laurent@mandrakesoft.com> 1.0.1-2mdk
- add BuildRequires

* Thu Nov  8 2001 Laurent Culioli <laurent@mandrakesoft.com> 1.0.1-1mdk
- updated to 1.0.1
- pam-support is back
- enabling virtual-user ( with puredb )
- patch config.pl to use the maxdiskusagepct option ( thanks to thomas.mangin@free.fr )
- update pure-ftpd.init
- clean specfile

* Wed Sep 19 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.2a-1mdk
- updated to 0.99.2.a 

* Mon Sep 17 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.2-2mdk
- fix files section

* Mon Sep 17 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.2-1mdk
- updated to 0.99.2

* Sun Sep 02 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.1b-5mdk
- fix

* Thu Aug 30 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.1b-4mdk
- aarggh...fix changelog ( i'm jeune , i'm naif )

* Thu Aug 30 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.1b-3mdk
- use pure-config.pl for pure-ftpd.init
- dont use -with-pam in configure

* Thu Aug 30 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.1b-2mdk
- fix pure-ftpd.init

* Wed Aug 29 2001 Laurent Culioli <laurent@mandrakesoft.com> 0.99.1b-1mdk
- first mandrake package
